unit converter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI, ComCtrls, XPMan;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    ProgressBar1: TProgressBar;
    XPManifest1: TXPManifest;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure RunDosCommand(Command : string);
  end;

var
  Form1: TForm1;

implementation

uses StrUtils;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  cmd : string;
  ffmpeg_name : string;
  wma_name : string;
  mp3_name : string;
begin
  if OpenDialog1.Execute = False then Exit;

  wma_name := OpenDialog1.FileName;
  mp3_name := StringReplace(wma_name, ExtractFileExt(wma_name), '.mp3', [rfReplaceAll]);
  ffmpeg_name := 'ffmpeg.exe';
  cmd := ffmpeg_name + ' -i "' + wma_name + '" -ab 128k -y -f mp3 "' + mp3_name + '"';
  RunDosCommand(cmd);

end;

procedure TForm1.RunDosCommand(Command : string);
var  
  hReadPipe : THandle;
  hWritePipe : THandle;
  SI : TStartUpInfo;
  PI : TProcessInformation;
  SA : TSecurityAttributes;
  SD : TSecurityDescriptor;
  BytesRead : DWORD;
  Dest : array[0..4095] of char;
  CmdLine : array[0..512] of char;
  S, Param : string;
  Avail, ExitCode, wrResult : DWORD;
  tmpStr : string;
  sIdx, eIdx : Integer;
  time : Integer;
  duration : Integer;
begin  
{ Dos Application }
    InitializeSecurityDescriptor(@SD, SECURITY_DESCRIPTOR_REVISION);
    SetSecurityDescriptorDacl(@SD, True, nil, False);
    SA.nLength := SizeOf(SA);
    SA.lpSecurityDescriptor := @SD;
    SA.bInheritHandle := True;
    CreatePipe(hReadPipe, hWritePipe, @SA, 1024);
    duration := 0;
    time := 0;
  try
    Screen.Cursor := crHourglass;
    { STARTUPINFO Ѵ. }
    FillChar(SI, SizeOf(SI), 0);
    SI.cb := SizeOf(TStartUpInfo);
    SI.wShowWindow := SW_HIDE;
    SI.dwFlags := STARTF_USESHOWWINDOW;
    { STARTF_USESTDHANDLES   PIPE  Redirect  ʴ´. }
    SI.dwFlags := SI.dwFlags or STARTF_USESTDHANDLES;
    SI.hStdOutput := hWritePipe;
    SI.hStdError := hWritePipe;
    StrPCopy(CmdLine, Command);

    { Process Ѵ. }
    if CreateProcess(nil, CmdLine, nil, nil, True, NORMAL_PRIORITY_CLASS, nil, nil, SI, PI) then
    begin
      ExitCode := 0;
      while ExitCode = 0 do
      begin
        wrResult := WaitForSingleObject(PI.hProcess, 500);
        { Pipe µ  ִ  Ѵ. }
        if PeekNamedPipe(hReadPipe, nil, 0, nil, @Avail, nil) then
        begin
          if Avail > 0 then
          begin
            { Redirect ȭ    . }
              FillChar(Dest, SizeOf(Dest), 0);
              ReadFile(hReadPipe, Dest, Avail, BytesRead, nil);
              tmpStr := StrPas(Dest);
              { ð ˻}
              if  duration = 0 then
              begin
                sIdx := Pos('Duration: ', tmpStr);
                if ( sIdx > 0) then
                begin
                   eIdx := PosEx(':', tmpStr, sIdx + 10);
                   time := StrToInt(Copy(tmpStr, sIdx + 10 , eIdx - sIdx - 10)) * 60 * 60;

                   sIdx := PosEx(':', tmpStr, eIdx + 1);
                   time := time + StrToInt(Copy(tmpStr, eIdx + 1, sIdx - eIdx - 1)) * 60;

                   eIdx := PosEx('.', tmpStr, sIdx + 1);
                   time := time + StrToInt(Copy(tmpStr, sIdx + 1 , eIdx - sIdx - 1));

                   duration := time;
                   ProgressBar1.Max := duration;

                end;
              end;

              {µǴ ð ؼ   Ȳ Ʈ Ѵ.}
              sIdx := Pos('time=', tmpStr);
              eIdx := PosEx('.', tmpStr, sIdx + 5);
              time := StrToInt(Copy(tmpStr, sIdx + 5 , eIdx - sIdx - 5));
              ProgressBar1.Position := time;
              Application.ProcessMessages;
          end;
        end;
        { WAIT_TIMEOUT ƴϸ  ģ. }
        if wrResult <> WAIT_TIMEOUT then
          ExitCode := 1;
      end;
      {  .. }
      GetExitCodeProcess(PI.hProcess, ExitCode);
      CloseHandle(PI.hProcess);
      CloseHandle(PI.hThread);
    end;
  finally
    CloseHandle(hReadPipe);
    CloseHandle(hWritePipe);
    Screen.Cursor := crDefault;
  end;
end;

end.
